var startA = new Date().getTime();

var SONOS_PORT = 1400; 
var URL_CONNECT_TIMEOUT = 100; // in miliseconds!!!
var STOP_COMMAND_INDEX = 1;
var DEF_REPEAT_TIME = 30; // seconds

var SONOS_ACTION_NOW_PLAYING = 0;
var SONOS_ACTION_PLAYLIST    = 1;
var SONOS_ACTION_FAVORITES   = 2;
var SONOS_ACTION_LIBRARY     = 3;
var SONOS_ACTION_TTS         = 4;
var SONOS_ACTION_COMMAND     = 5;

var INVALID_PLAYER_ID = -1;

var COMMAND_NONE = 0;
var COMMAND_STOP = 1;
var COMMAND_PLAY = 2;
var COMMAND_PAUSE = 3;
var COMMAND_MUTE = 4;
var COMMAND_UNMUTE = 5;
var COMMAND_VOLUME_UP = 6;
var COMMAND_VOLUME_DOWN = 7;

var VOLUME_STEP = 10;

var TMP_SONOS_QUEUE_NAME = "dSS-tmp";

var predefinedUnduEvents = new Array(76, 65, 74, 83, 84, 85);
var predefinedStopActivities = new Array({scene:72, group:0, zone:0, type:'zone-scene'});  // leaving home


var predefinedRoomEvents = new Array();
predefinedRoomEvents[COMMAND_PAUSE] = new Array({name:'Preset 0', id:0, group:4},
                                                {name:'Preset 10', id:32, group:4},
                                                {name:'Preset 20', id:34, group:4},
                                                {name:'Preset 30', id:36, group:4},
                                                {name:'Preset 40', id:38, group:4},
                                                {name:'Standby', id:67, group:4},
                                                {name:'Deep-off', id:68, group:4},
                                                {name:'Leave Home', id:72, group:4});

predefinedRoomEvents[COMMAND_PLAY] = new Array({name:'Preset 1', id:5, group:4},
                                               {name:'Preset 11', id:33, group:4},
                                               {name:'Preset 21', id:35, group:4},
                                               {name:'Preset 31', id:37, group:4},
                                               {name:'Preset 41', id:39, group:4});
/*                                                
predefinedRoomEvents[COMMAND_VOLUME_UP] = new Array({name:'Volume Up', id:12, group:4});                                             
predefinedRoomEvents[COMMAND_VOLUME_DOWN] = new Array({name:'Volume Down', id:11, group:4});                                             
*/
                                     
function cleanXMLText(sXML) {
  return sXML.replace(/&(lt|gt|quot|amp;apos);/g, function(m, t) {
                            switch (t) {
                              case 'lt':
                                return '<';
                              case 'gt':
                                return '>';
                              case 'quot':   
                                return '\"';
                              case 'amp;apos':
                                return "\'";
                              default:
                               return "";
                            }
                         }); 
} 

function secondToInt(sSeconds) {
  var a = sSeconds.split(':');
  return ((+a[0]) * 3600) + ((+a[1]) * 60) + (+a[2]); 
}

function storeSubParameter(root, path, value) {
  Property.setProperty(root +'/' + path, value);
  Property.setFlag(root + '/' + path, 'ARCHIVE', true);
  lInfo.logln("STORING " + root + "/" + path + " -> " + value);
}

function storeSubParameterFull(path, value) {
  Property.setProperty(path, value);
  Property.setFlag(path, 'ARCHIVE', true);
  lInfo.logln("STORING " +path + " -> " + value);
}

 
function getXMLFields(szXMLRespond, szXMLFieldName, szXMLCloseName) {
    szXMLCloseName = typeof szXMLCloseName !== 'undefined' ? szXMLCloseName : '';
    var sEnd = '</' + szXMLFieldName + ">"
    if (szXMLCloseName != '')
     sEnd = szXMLCloseName;
 
    var xml_text = cleanXMLText(szXMLRespond);
   // lInfo.logln("Value: " + xml_text);    
    
    var returnValues = new Array();
    do
    {        
        var start_pos = xml_text.indexOf("<" + szXMLFieldName+" ");
        var end_pos = xml_text.indexOf(sEnd) + sEnd.length;
       // lInfo.logln("Pos: " + start_pos + ","+end_pos);

        if (start_pos == -1 || end_pos == -1)
            break;

        var searched_value = xml_text.substring(start_pos, end_pos);
      //  lInfo.logln("Value: " + searched_value);

        if (searched_value.length > 0)
          returnValues.push({data:searched_value});
          
        xml_text = xml_text.substring(end_pos);
    }
    while (xml_text != '')
    
    return returnValues;
}

function addSlavePlayersToGroup(sSlaves, arraySonosGroups, sMasterGroupDevice, curl_options) {
  if (sSlaves != "") {
    var arraySlaves = sSlaves.split(';');  
    for (var xIndex=0;xIndex<arraySlaves.length;xIndex++) {
      var sSlaveID = arraySlaves[xIndex].trim();
      if (sSlaveID != '') { 
        var sSlaveIP = getZoneGroupMemberIP(arraySonosGroups, sSlaveID);
        if (sSlaveIP != "") { 
          lInfo.logln("Adding slave to tmpGroup "+sSlaveIP);
          upnpSetContentSrc(sSlaveIP, "x-rincon:"+sMasterGroupDevice, curl_options);
        }
      }
    }
  }
}

function getZoneGroupMemberIP(aGroups, sDeviceID) {
  if (aGroups != null) {
    for (var iIndex=0;iIndex<aGroups.length;iIndex++) {
      var aMembers = aGroups[iIndex].members; 
      if (aMembers != null) {
        for (var xIndex=0;xIndex<aMembers.length;xIndex++) {
          var tmpDevice = aMembers[xIndex].match(/UUID=\"(.*?)\"/); 
          if (tmpDevice != null) {
            if (tmpDevice[1] == sDeviceID) {
lInfo.logln("FOUND DEVICE IN XML "+sDeviceID);   
              var tmpIP = aMembers[xIndex].match(/Location=\"(.*?)\"/);
              if (tmpIP != null) {
                var matches = tmpIP[1].match(/:\/\/(.[^:]+)/); // get ip from full url
                if (matches != null) {
                  sDeviceIP = matches[1];
                  return sDeviceIP;
                }
              }
            }
          } 
        }
      }
    }
  }
  return "";
}  

function replaceAll(find, replace, str) {
  return str.replace(new RegExp(find, 'g'), replace);
}

var Utf8 = {
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
};

 
