/** 
 @file events.js
 
 @brief This file contain implementation of the event handling from the upnp ui.

 @author: mobile2DS

 @date: 15.12.2013
*/

var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sonos-controller.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function getPlayersToExecUndo(oActvity) {
  var arrayPlayers = new Array();
  if (oActvity != null) {
    if (JSON.parse(oActvity.getChild('allRooms').getValue())) {// all players
       var baseNode = Property.getNode('sonos-players');
       if (baseNode != null) {
         var oArrayNode = baseNode.getChildren();
         for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
           if (!JSON.parse(oArrayNode[iIndex].getChild('disabled').getValue())) 
             arrayPlayers.push(new Object({id:oArrayNode[iIndex].getChild('id').getValue(),
                                           device:oArrayNode[iIndex].getChild('deviceID').getValue(),
                                           ip:oArrayNode[iIndex].getChild('ipAddress').getValue()
                                          }));
         }
       }
    }
    else {
      // only selected players/rooms
      var baseNode = oActvity.getChild('pickedRooms');
      if (baseNode != null && baseNode.getChild('pickedRooms') != null) {
        var sRooms = baseNode.getChild('pickedRooms').getValue();
        if (sRooms != null) {
          var rooms = unescape(sRooms).split(";");
          var oArrayNode = Property.getNode('sonos-players').getChildren();
          for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
            if (!JSON.parse(oArrayNode[iIndex].getChild('disabled').getValue())) {
              if (rooms.indexOf(oArrayNode[iIndex].getChild('roomID').getValue())>-1)
                arrayPlayers.push(new Object({id:oArrayNode[iIndex].getChild('id').getValue(),
                                            device:oArrayNode[iIndex].getChild('deviceID').getValue(),
                                            ip:oArrayNode[iIndex].getChild('ipAddress').getValue()}));
            }
          }
        }
      }
    }
  }
  return arrayPlayers;
}


/* ---------------------------------------------------------------------------
                        EVENT handling
*/
if (raisedEvent.name === 'running') {
     lInfo.logln("running sonos events.js");
}
else if (raisedEvent.name === 'undoScene') {
  try {    
/*   
    var curl_options = new Object({'debug' : 1, 'connectTimeout' : 200});  
    upnpStop("192.168.1.108", curl_options)
var end = new Date().getTime();
var time = end - start;
lInfo.logln("Execution time: " + time);    
lInfo.logln("Execution timeF: " + (end - startA));    
*/
    lInfo.logln("undoScene zoneID/groupID/sceneID:  " +  raisedEvent.source.zoneID +" / " +raisedEvent.source.groupID+ " / "+ raisedEvent.parameter.sceneID);

    var nGroupID =  parseInt("" + raisedEvent.source.groupID, 10);
    var nSceneID =  parseInt("" + raisedEvent.parameter.sceneID, 10);
    var curl_options = new Object({'debug' : 1,'connectTimeout' : 200 });    
    
    if (nGroupID == 0 && predefinedUnduEvents.indexOf(nSceneID) > -1) {
      //var baseNode = Property.getNode('sonos-alarms');
      var restartData = null;
      
      // find sceneID in activities
      var arrayPlayers = null;
      var baseNode = Property.getNode('sonos-activities');
      if (baseNode != null) {
        var oArrayNode = baseNode.getChildren();
        var bFound = false;
        var bGrouping = false;
        for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
          var oChildNode = oArrayNode[iIndex];
lInfo.logln("Activity ID="+ oChildNode.getChild('id').getValue());
          var oTriggers = oChildNode.getChild('triggers').getChildren();
          if (oTriggers != null) {
            for ( var yIndex = 0; yIndex < oTriggers.length; yIndex++) {
              var oChildTrigger = oTriggers[yIndex];
lInfo.logln("Trigger type="+ oChildTrigger.getChild('type').getValue());
              switch(nSceneID) {
                case 76: // fire trigger does not store sceneID
                   if (oChildTrigger.getChild('name') != null && oChildTrigger.getChild('state') != null &&
                       oChildTrigger.getChild('name').getValue() == 'fire' && oChildTrigger.getChild('state').getValue() == 'active') {
                     arrayPlayers = getPlayersToExecUndo(oChildNode);
                     bGrouping = JSON.parse(oChildNode.getChild('createSonosGroup').getValue()); 
                     bFound = true;
                     break;
                   }
                break;

                default:
                   if (oChildTrigger.getChild('scene') != null && oChildTrigger.getChild('scene').getValue() == nSceneID) {
                     arrayPlayers = getPlayersToExecUndo(oChildNode);
                     bGrouping = JSON.parse(oChildNode.getChild('createSonosGroup').getValue()); 
                     bFound = true;
                     break;
                   }
                break;               
              }
            }
            if (bFound)
              break;
          }
        }
      }
      
      if (bGrouping) {
        var baseNode = Property.getNode('sonos-grouping');
        if (baseNode != null) {
          arrayPlayers = null;
          if (baseNode.getChild('data') != null) {
            nStoredGroupSceneID = parseInt(baseNode.getChild('sceneID').getValue(),10); 
            if (nStoredGroupSceneID == nSceneID) {
              sValue = baseNode.getChild('data').getValue();
              if (sValue != "") {
                sValue = unescape(sValue);//replaceAll('&quot;','"',sValue); 
                arrayPlayers = JSON.parse(sValue);
              }
            }
          }
        }
      }                              
      lInfo.logln(">>>>>>>UNDO ExecPlayers:"+JSON.stringify(arrayPlayers));             
      
      if (arrayPlayers != null && arrayPlayers.length > 0) {       
        var arraySonosGroups = null;
        for (var iIndex=0;iIndex<arrayPlayers.length;iIndex++) {
          var sPlayerIP = arrayPlayers[iIndex].ip;
          var sDeviceID = arrayPlayers[iIndex].device;
          var sPlayerID = arrayPlayers[iIndex].id;
         
          if (bGrouping) { 
            if (arraySonosGroups == null)
              arraySonosGroups = upnpGetSonosGroups(sPlayerIP, curl_options);
          
            upnpSetPlayerAsStandAloneGroup(sPlayerIP, curl_options);
            addSlavePlayersToGroup(arrayPlayers[iIndex].slaves, arraySonosGroups, sDeviceID, curl_options);
          }
          
          var undoData = handleUndoActivity(sPlayerID,0,nSceneID);
          if (undoData != null) {
            var restartData = undoData.restoreData; 
        lInfo.logln("Undo restart data:"+JSON.stringify(restartData));             
            if (restartData != null) {
              if (restartData.activeQueueID != "") {
                // loadingOldQueue
                var aTmp = restartData.activeQueueID.split(':');
                if (aTmp != null && aTmp.length==2) {
                  var sQueueNr = aTmp[1];
                  upnpClearQueue(restartData.playerIP, curl_options);
                  upnpLoadPlaylist(restartData.playerIP, "file:///jffs/settings/savedqueues.rsq#"+sQueueNr, curl_options);                    
                }
                lInfo.logln("Deleting tmp queue");  
                upnpDeleteQueueFromList(restartData.playerIP, restartData.activeQueueID, curl_options);
              }
             
              if (restartData.volumeReset) {
                upnpSetVolume(restartData.playerIP, restartData.volumeDef, curl_options);
                
                if (arrayPlayers[iIndex].IPSlaves != null) {
                  lInfo.logln("Reset also slaves");
                  var aSlaves = null;
                  if (arrayPlayers[iIndex].IPSlaves.length > 0) {
                    aSlaves = arrayPlayers[iIndex].IPSlaves.split(","); 
                  }
                  
                  var aSlavesVolumes = null;
                  if (restartData.volumeSlaves != null && restartData.volumeSlaves.length > 0) {
                    aSlavesVolumes = restartData.volumeSlaves.split(","); 
                  }
                  lInfo.logln("Reset also slaves2");
                  if (aSlaves != null && aSlaves.length > 0) {
                    for (var iIndex=0;iIndex<aSlaves.length;iIndex++) {
                      var sSlaveIP = aSlaves[iIndex].trim();
                      
                      var nSlaveVolume = restartData.volumeDef;
                      if (aSlavesVolumes != null && aSlavesVolumes[iIndex] != null) {
                        var tmpVolume = parseInt(""+aSlavesVolumes[iIndex],10);
                        if (tmpVolume > -1) 
                          nSlaveVolume = tmpVolume;
                      }
                      
                      lInfo.logln("Reset slave volume for "+sSlaveIP+" to "+nSlaveVolume);
                      upnpSetVolume(sSlaveIP, nSlaveVolume, curl_options);
                    }
                  }
                }
              }
              upnpSetPlayMode(restartData.playerIP, restartData.playMode, curl_options);

              if (!restartData.isRadio) {
    lInfo.logln("Undo Restarting music:"+restartData.playerIP+"/x-rincon-queue:"+sDeviceID+"#0"+"/"+restartData.activeAction); 
               // activating queue
                upnpSetContentSrc(restartData.playerIP, "x-rincon-queue:"+sDeviceID+"#0", curl_options);
                upnpSeek(restartData.playerIP, true, restartData.trackListPos, curl_options);
                upnpSeek(restartData.playerIP, false, restartData.trackPlayPos, curl_options);
                if (restartData.activeAction == "PLAYING")
                  upnpPlay(restartData.playerIP, curl_options);
              } 
              else {
    lInfo.logln("Undo  Restarting radio:"+restartData.playUrl+"/"+restartData.activeAction); 
                upnpStop(restartData.playerIP, curl_options);
                upnpSetRadio(restartData.playerIP, restartData.playUrl, "Radio", curl_options);
                if (restartData.activeAction == "PLAYING")
                  upnpPlay(restartData.playerIP, curl_options);
              }
            }
            else {
              if (undoData.performStop) {
                lInfo.logln("No sonos player undo, stop event music");
                upnpStop(sPlayerIP, curl_options);
              }
            }
          }
        }
        
        if (bGrouping) {
          storeSubParameter('sonos-grouping', 'data', '');
          storeSubParameter('sonos-grouping', 'sceneID', 0);
          Property.store();
        }
      }
    }
  }
  catch (e) {
        lInfo.logln("Error by undoScene: " + e);
        for ( var i in e) {
            lInfo.logln(i + ': ' + e[i]);
        }                        
  }    
  
}
